'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _query = require('../utils/query');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Layer = function (_PureComponent) {
  _inherits(Layer, _PureComponent);

  function Layer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Layer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Layer.__proto__ || Object.getPrototypeOf(Layer)).call.apply(_ref, [this].concat(args))), _this), _this.add = function () {
      var _this$props = _this.props,
          layerManager = _this$props.layerManager,
          onAfterAdd = _this$props.onAfterAdd,
          props = _objectWithoutProperties(_this$props, ['layerManager', 'onAfterAdd']);

      var source = props.source,
          render = props.render,
          params = props.params,
          sqlParams = props.sqlParams;


      var sourceParsed = source.parse === false ? source : JSON.parse((0, _query.replace)(JSON.stringify(source), params, sqlParams));

      var renderParsed = render.parse === false ? render : JSON.parse((0, _query.replace)(JSON.stringify(render), params, sqlParams));

      layerManager.add(Object.assign({}, props, {
        source: sourceParsed,
        render: renderParsed
      }), {}, onAfterAdd);
    }, _this.update = function (changedProps) {
      var _this$props2 = _this.props,
          layerManager = _this$props2.layerManager,
          id = _this$props2.id;


      layerManager.update(id, changedProps);
    }, _this.remove = function () {
      var _this$props3 = _this.props,
          layerManager = _this$props3.layerManager,
          id = _this$props3.id;

      layerManager.remove(id);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Layer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.add();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var prevSource = prevProps.source,
          prevRender = prevProps.render,
          prevParams = prevProps.params,
          prevSqlParams = prevProps.sqlParams,
          prevDecodeParams = prevProps.decodeParams,
          prevOpacity = prevProps.opacity,
          prevVisibility = prevProps.visibility,
          prevZIndex = prevProps.zIndex;
      var _props = this.props,
          type = _props.type,
          source = _props.source,
          render = _props.render,
          params = _props.params,
          sqlParams = _props.sqlParams,
          decodeParams = _props.decodeParams,
          opacity = _props.opacity,
          visibility = _props.visibility,
          zIndex = _props.zIndex;

      // Check that source has changed

      var prevSourceParsed = prevSource.parse === false ? prevSource : JSON.parse((0, _query.replace)(JSON.stringify(prevSource), prevParams, prevSqlParams));

      var sourceParsed = source.parse === false ? source : JSON.parse((0, _query.replace)(JSON.stringify(source), params, sqlParams));

      // Check that render has changed
      var prevRenderParsed = prevRender.parse === false ? prevRender : JSON.parse((0, _query.replace)(JSON.stringify(prevRender), prevParams, prevSqlParams));

      var renderParsed = render.parse === false ? render : JSON.parse((0, _query.replace)(JSON.stringify(render), params, sqlParams));

      // TODO: don't add and remove if provider is geojson
      if (sourceParsed && !(0, _isEqual2.default)(sourceParsed, prevSourceParsed)) {
        var sourceType = sourceParsed.type,
            data = sourceParsed.data;

        var t = sourceType || type;

        if (t === 'raster' || t === 'vector' || t === 'geojson' && typeof data === 'string') {
          this.remove();
          this.add();

          // prevent updating layer
          return;
        }
      }

      if (renderParsed && !(0, _isEqual2.default)(renderParsed, prevRenderParsed)) {
        var _renderParsed$layers = renderParsed.layers,
            layers = _renderParsed$layers === undefined ? [] : _renderParsed$layers;
        var _prevRenderParsed$lay = prevRenderParsed.layers,
            prevLayers = _prevRenderParsed$lay === undefined ? [] : _prevRenderParsed$lay;


        if (layers.length !== prevLayers.length) {
          this.remove();
          this.add();

          // prevent updating layer
          return;
        }
      }

      var changedProps = Object.assign({}, opacity !== prevOpacity && {
        opacity: opacity
      }, visibility !== prevVisibility && {
        visibility: visibility
      }, zIndex !== prevZIndex && {
        zIndex: zIndex
      }, !(0, _isEqual2.default)(sourceParsed, prevRenderParsed) && {
        source: sourceParsed
      }, !(0, _isEqual2.default)(renderParsed, prevRenderParsed) && {
        render: renderParsed
      }, !(0, _isEqual2.default)(decodeParams, prevDecodeParams) && {
        decodeParams: decodeParams
      });

      if (!(0, _isEmpty2.default)(changedProps)) {
        this.update(changedProps);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.remove();
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return Layer;
}(_react.PureComponent);

Layer.propTypes = {
  id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired,

  source: _propTypes2.default.shape({
    parse: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func])
  }),
  render: _propTypes2.default.shape({
    parse: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func])
  }),

  params: _propTypes2.default.shape({}),
  sqlParams: _propTypes2.default.shape({}),
  decodeParams: _propTypes2.default.shape({}),

  opacity: _propTypes2.default.number,
  visibility: _propTypes2.default.bool,
  zIndex: _propTypes2.default.number,

  onAfterAdd: _propTypes2.default.func,

  layerManager: _propTypes2.default.shape({
    add: _propTypes2.default.func.isRequired,
    update: _propTypes2.default.func.isRequired,
    remove: _propTypes2.default.func.isRequired,
    map: _propTypes2.default.shape({
      getSource: _propTypes2.default.func
    })
  })
};
Layer.defaultProps = {
  params: undefined,
  sqlParams: undefined,
  decodeParams: undefined,
  opacity: 1,
  visibility: true,
  zIndex: undefined,

  source: {
    parse: true
  },
  render: {},

  layerManager: null,

  onAfterAdd: function onAfterAdd() {}
};
exports.default = Layer;