'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _DEFAULT_TEXTURE_PARA;

var _constants = require('@luma.gl/constants');

var _constants2 = _interopRequireDefault(_constants);

var _core = require('@deck.gl/core');

var _core2 = require('@luma.gl/core');

var _bitmapLayerVertex = require('./bitmap-layer-vertex');

var _bitmapLayerVertex2 = _interopRequireDefault(_bitmapLayerVertex);

var _bitmapLayerFragment = require('./bitmap-layer-fragment');

var _bitmapLayerFragment2 = _interopRequireDefault(_bitmapLayerFragment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /* eslint-disable */
// Copyright (c) 2015 Uber Technologies, Inc.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

/* global HTMLVideoElement */


var DEFAULT_TEXTURE_PARAMETERS = (_DEFAULT_TEXTURE_PARA = {}, _defineProperty(_DEFAULT_TEXTURE_PARA, _constants2.default.TEXTURE_MIN_FILTER, _constants2.default.LINEAR), _defineProperty(_DEFAULT_TEXTURE_PARA, _constants2.default.TEXTURE_MAG_FILTER, _constants2.default.LINEAR), _defineProperty(_DEFAULT_TEXTURE_PARA, _constants2.default.TEXTURE_WRAP_S, _constants2.default.CLAMP_TO_EDGE), _defineProperty(_DEFAULT_TEXTURE_PARA, _constants2.default.TEXTURE_WRAP_T, _constants2.default.CLAMP_TO_EDGE), _DEFAULT_TEXTURE_PARA);

var defaultProps = {
  image: { type: 'object', value: null, async: true },
  bounds: { type: 'array', value: [1, 0, 0, 1], compare: true },

  desaturate: { type: 'number', min: 0, max: 1, value: 0 },
  // More context: because of the blending mode we're using for ground imagery,
  // alpha is not effective when blending the bitmap layers with the base map.
  // Instead we need to manually dim/blend rgb values with a background color.
  transparentColor: { type: 'color', value: [0, 0, 0, 0] },
  tintColor: { type: 'color', value: [255, 255, 255] }
};

/*
 * @class
 * @param {object} props
 * @param {number} props.transparentColor - color to interpret transparency to
 * @param {number} props.tintColor - color bias
 */

var BitmapLayer = function (_Layer) {
  _inherits(BitmapLayer, _Layer);

  function BitmapLayer() {
    _classCallCheck(this, BitmapLayer);

    return _possibleConstructorReturn(this, (BitmapLayer.__proto__ || Object.getPrototypeOf(BitmapLayer)).apply(this, arguments));
  }

  _createClass(BitmapLayer, [{
    key: 'getShaders',
    value: function getShaders() {
      return _get(BitmapLayer.prototype.__proto__ || Object.getPrototypeOf(BitmapLayer.prototype), 'getShaders', this).call(this, { vs: _bitmapLayerVertex2.default, fs: _bitmapLayerFragment2.default, modules: ['project32', 'picking'] });
    }
  }, {
    key: 'initializeState',
    value: function initializeState() {
      var attributeManager = this.getAttributeManager();

      attributeManager.add({
        positions: {
          size: 3,
          type: _constants2.default.DOUBLE,
          fp64: this.use64bitPositions(),
          update: this.calculatePositions,
          noAlloc: true
        }
      });

      this.setState({
        numInstances: 1,
        positions: new Float64Array(12)
      });
    }
  }, {
    key: 'updateState',
    value: function updateState(_ref) {
      var props = _ref.props,
          oldProps = _ref.oldProps,
          changeFlags = _ref.changeFlags;

      // setup model first
      if (changeFlags.extensionsChanged) {
        var gl = this.context.gl;

        if (this.state.model) {
          this.state.model.delete();
        }
        this.setState({ model: this._getModel(gl) });
        this.getAttributeManager().invalidateAll();
      }

      if (props.image !== oldProps.image) {
        this.loadTexture(props.image);
      }

      var attributeManager = this.getAttributeManager();

      if (props.bounds !== oldProps.bounds) {
        attributeManager.invalidate('positions');
      }
    }
  }, {
    key: 'finalizeState',
    value: function finalizeState() {
      _get(BitmapLayer.prototype.__proto__ || Object.getPrototypeOf(BitmapLayer.prototype), 'finalizeState', this).call(this);

      if (this.state.bitmapTexture) {
        this.state.bitmapTexture.delete();
      }
    }
  }, {
    key: 'calculatePositions',
    value: function calculatePositions(attributes) {
      var positions = this.state.positions;
      var bounds = this.props.bounds;
      // bounds as [minX, minY, maxX, maxY]

      if (Number.isFinite(bounds[0])) {
        /*
          (minX0, maxY3) ---- (maxX2, maxY3)
                 |                  |
                 |                  |
                 |                  |
          (minX0, minY1) ---- (maxX2, minY1)
        */
        positions[0] = bounds[0];
        positions[1] = bounds[1];
        positions[2] = 0;

        positions[3] = bounds[0];
        positions[4] = bounds[3];
        positions[5] = 0;

        positions[6] = bounds[2];
        positions[7] = bounds[3];
        positions[8] = 0;

        positions[9] = bounds[2];
        positions[10] = bounds[1];
        positions[11] = 0;
      } else {
        // [[minX, minY], [minX, maxY], [maxX, maxY], [maxX, minY]]
        for (var i = 0; i < bounds.length; i++) {
          positions[i * 3 + 0] = bounds[i][0];
          positions[i * 3 + 1] = bounds[i][1];
          positions[i * 3 + 2] = bounds[i][2] || 0;
        }
      }

      attributes.value = positions;
    }
  }, {
    key: '_getModel',
    value: function _getModel(gl) {
      if (!gl) {
        return null;
      }

      /*
        0,1 --- 1,1
         |       |
        0,0 --- 1,0
      */
      return new _core2.Model(gl, Object.assign({}, this.getShaders(), {
        id: this.props.id,
        geometry: new _core2.Geometry({
          drawMode: _constants2.default.TRIANGLE_FAN,
          vertexCount: 4,
          attributes: {
            texCoords: new Float32Array([0, 0, 0, 1, 1, 1, 1, 0])
          }
        }),
        isInstanced: false
      }));
    }
  }, {
    key: 'draw',
    value: function draw(opts) {
      var uniforms = opts.uniforms;
      var _state = this.state,
          bitmapTexture = _state.bitmapTexture,
          model = _state.model;
      var _props = this.props,
          image = _props.image,
          desaturate = _props.desaturate,
          transparentColor = _props.transparentColor,
          tintColor = _props.tintColor;

      // Update video frame

      if (bitmapTexture && image instanceof HTMLVideoElement && image.readyState > HTMLVideoElement.HAVE_METADATA) {
        var sizeChanged = bitmapTexture.width !== image.videoWidth || bitmapTexture.height !== image.videoHeight;
        if (sizeChanged) {
          // note clears image and mipmaps when resizing
          bitmapTexture.resize({ width: image.videoWidth, height: image.videoHeight, mipmaps: true });
          bitmapTexture.setSubImageData({
            data: image,
            parameters: Object.assign({}, DEFAULT_TEXTURE_PARAMETERS, _defineProperty({}, _constants2.default.UNPACK_FLIP_Y_WEBGL, true))
          });
        } else {
          bitmapTexture.setSubImageData({
            data: image,
            parameters: _defineProperty({}, _constants2.default.UNPACK_FLIP_Y_WEBGL, true)
          });
        }

        bitmapTexture.generateMipmap();
      }

      // // TODO fix zFighting
      // Render the image
      if (bitmapTexture && model) {
        model.setUniforms(Object.assign({}, uniforms, {
          bitmapTexture: bitmapTexture,
          desaturate: desaturate,
          transparentColor: transparentColor.map(function (x) {
            return x / 255;
          }),
          tintColor: tintColor.slice(0, 3).map(function (x) {
            return x / 255;
          })
        })).draw();
      }
    }
  }, {
    key: 'loadTexture',
    value: function loadTexture(image) {
      var gl = this.context.gl;


      if (this.state.bitmapTexture) {
        this.state.bitmapTexture.delete();
      }

      if (image instanceof _core2.Texture2D) {
        this.setState({ bitmapTexture: image });
      } else if (image instanceof HTMLVideoElement) {
        // Initialize an empty texture while we wait for the video to load
        this.setState({
          bitmapTexture: new _core2.Texture2D(gl, {
            width: 1,
            height: 1,
            parameters: DEFAULT_TEXTURE_PARAMETERS,
            unpackFlipY: false,
            pixelStore: _defineProperty({}, _constants2.default.UNPACK_FLIP_Y_WEBGL, false),
            mipmaps: false
          })
        });
      } else if (image) {
        // Browser object: Image, ImageData, HTMLCanvasElement, ImageBitmap
        this.setState({
          bitmapTexture: new _core2.Texture2D(gl, {
            data: image,
            parameters: DEFAULT_TEXTURE_PARAMETERS
          })
        });
      }
    }
  }]);

  return BitmapLayer;
}(_core.Layer);

exports.default = BitmapLayer;


BitmapLayer.layerName = 'BitmapLayer';
BitmapLayer.defaultProps = defaultProps;