"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = "\n#define SHADER_NAME bitmap-layer-fragment-shader\n\n#ifdef GL_ES\nprecision highp float;\n#endif\n\nuniform sampler2D bitmapTexture;\n\nvarying vec2 vTexCoord;\n\n{decodeParams}\n\nuniform float opacity;\nuniform float zoom;\n\n\nvec4 decodeFunction(vec3 color, float alpha) {\n  {decodeFunction}\n  return vec4(color, alpha * opacity);\n}\n\nvoid main(void) {\n  vec4 bitmapColor = texture2D(bitmapTexture, vTexCoord);\n\n  // clear mask\n  if (bitmapColor == vec4(0., 0., 0., 1.)) {\n    discard;\n  }\n\n  // custom decode\n  gl_FragColor = decodeFunction(bitmapColor.rgb, bitmapColor.a);\n\n  // use highlight color if this fragment belongs to the selected object.\n  gl_FragColor = picking_filterHighlightColor(gl_FragColor);\n\n  // use picking color if rendering to picking FBO.\n  gl_FragColor = picking_filterPickingColor(gl_FragColor);\n}\n";