'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('../../utils/promise');

var _promise2 = _interopRequireDefault(_promise);

var _vectorStyleLayers = require('../../utils/vector-style-layers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var VectorLayer = function VectorLayer(layerModel, providers) {
  var _layerModel$source = layerModel.source,
      source = _layerModel$source === undefined ? {} : _layerModel$source,
      _layerModel$render = layerModel.render,
      render = _layerModel$render === undefined ? {} : _layerModel$render,
      id = layerModel.id;
  var provider = source.provider;
  var layers = render.layers;


  var layer = Object.assign({
    id: id,
    source: Object.assign({
      type: 'vector'
    }, source)
  }, render, {
    layers: (0, _vectorStyleLayers.getVectorStyleLayers)(layers, layerModel)
  });

  if (provider) {
    var method = providers[provider.type];

    return new _promise2.default(function (resolve, reject) {
      if (!method) {
        reject(new Error(provider.type + ' provider is not supported. Try to add it to the providers method when you initialize layer-manager'));
      }

      method.call(undefined, layerModel, layer, resolve, reject);
    });
  }

  return new _promise2.default(function (resolve, reject) {
    if (layer) {
      resolve(layer);
    } else {
      reject(new Error('error in layer config'));
    }
  });
};

exports.default = VectorLayer;