'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('../../utils/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var VideoLayer = function VideoLayer(layerModel) {
  var _layerModel$source = layerModel.source,
      source = _layerModel$source === undefined ? {} : _layerModel$source,
      render = layerModel.render,
      id = layerModel.id;


  var layer = Object.assign({
    id: id,
    type: 'raster',
    source: Object.assign({}, source, {
      type: 'video-tiled',
      // tiles: [ "https://storage.googleapis.com/skydipper_materials/movie-tiles/MODIS/{z}/{x}/{y}.mp4" ],
      tiles: ['https://storage.googleapis.com/skydipper_materials/movie-tiles/EVI_TEST/{z}/{x}/{y}.mp4'],
      scheme: 'xyz',
      tileSize: 256,
      minzoom: 1,
      maxzoom: 4,
      playbackRate: 0.1
      // geometryFilter: 'https://storage.googleapis.com/deltares-video-map/mapbox-test/test1/geometry-filter.geojson'
    })
  }, render, {
    layers: [{
      id: id + '-raster',
      type: 'raster',
      source: id
    }]
  });

  return new _promise2.default(function (resolve, reject) {
    if (layer) {
      resolve(layer);
    } else {
      reject(new Error('error in layer config'));
    }
  });
};

exports.default = VideoLayer;