'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchGeojsonData = undefined;

var _query = require('../utils/query');

var _axios = require('axios');

var _request = require('../lib/request');

var fetchGeojsonData = exports.fetchGeojsonData = function fetchGeojsonData(layerModel) {
  var source = layerModel.source,
      params = layerModel.params,
      sqlParams = layerModel.sqlParams,
      layerRequest = layerModel.layerRequest;


  var sourceParsed = source.parse === false || typeof source.parse === 'function' ? source : JSON.parse((0, _query.replace)(JSON.stringify(source), params, sqlParams));

  var _ref = sourceParsed || {},
      data = _ref.data;

  if (layerRequest) {
    layerRequest.cancel('Operation canceled by the user.');
  }

  var layerRequestSource = _axios.CancelToken.source();
  layerModel.set('layerRequest', layerRequestSource);

  var newLayerRequest = (0, _request.get)(data, { cancelToken: layerRequestSource.token }).then(function (res) {
    if (res.status > 400) {
      console.error(res);
      return false;
    }

    return res.data;
  });

  return newLayerRequest;
};

exports.default = { fetchGeojsonData: fetchGeojsonData };